﻿import { TableBase } from "../Engine/CatanEngine/TableV3/Core/TableBase";
import { TableManager } from "../Engine/CatanEngine/TableV3/TableManager";
//#region AutoMappingImport
import { Bar1401Table } from "./Tables/Bar1401Table";
import { BetSettingTable } from "./Tables/BetSettingTable";
import { Bingo8starsTable } from "./Tables/Bingo8starsTable";
import { Bingo9starsTable } from "./Tables/Bingo9starsTable";
import { BingoTable } from "./Tables/BingoTable";
import { CardUpgradeTable } from "./Tables/CardUpgradeTable";
import { ChatTable } from "./Tables/ChatTable";
import { Cluster1302Table } from "./Tables/Cluster1302Table";
import { Cluster1303Table } from "./Tables/Cluster1303Table";
import { Collect001Table } from "./Tables/Collect001Table";
import { Collect002Table } from "./Tables/Collect002Table";
import { CompositeTable } from "./Tables/CompositeTable";
import { CurrencyTable, CurrencyTableRow } from "./Tables/CurrencyTable";
import { Fish2003Table } from "./Tables/Fish2003Table";
import { Fish2004Table } from "./Tables/Fish2004Table";
import { FiveTable } from "./Tables/FiveTable";
import { FixedTable, FixedTableRow } from "./Tables/FixedTable";
import { FormreadTable, FormreadTableRow } from "./Tables/FormreadTable";
import { GiftTable } from "./Tables/GiftTable";
import { HeadTable, HeadTableRow } from "./Tables/HeadTable";
import { ItemdropTable } from "./Tables/ItemdropTable";
import { ItemmoneyTable } from "./Tables/ItemmoneyTable";
import { ItemSettingTable } from "./Tables/ItemSettingTable";
import { LanguageTable } from "./Tables/LanguageTable";
import { LevelTable, LevelTableRow } from "./Tables/LevelTable";
import { LineTable } from "./Tables/LineTable";
import { LobbyTable } from "./Tables/LobbyTable";
import { MailTable } from "./Tables/MailTable";
import { MonkeytowerTable } from "./Tables/MonkeytowerTable";
import { NameTable } from "./Tables/NameTable";
import { NetworkTable } from "./Tables/NetworkTable";
import { NineSicboTable } from "./Tables/NineSicboTable";
import { NormalBaccaratTable } from "./Tables/NormalBaccaratTable";
import { OperationTable } from "./Tables/OperationTable";
import { PacketTable } from "./Tables/PacketTable";
import { RankTable, RankTableRow } from "./Tables/RankTable";
import { ShopTable } from "./Tables/ShopTable";
import { Slot001Table } from "./Tables/Slot001Table";
import { Slot002Table } from "./Tables/Slot002Table";
import { Slot003Table } from "./Tables/Slot003Table";
import { Slot004Table } from "./Tables/Slot004Table";
import { Slot005Table } from "./Tables/Slot005Table";
import { Slot006Table } from "./Tables/Slot006Table";
import { Slot007Table } from "./Tables/Slot007Table";
import { Slot008Table } from "./Tables/Slot008Table";
import { Slot009Table } from "./Tables/Slot009Table";
import { Slot010Table } from "./Tables/Slot010Table";
import { Slot011Table } from "./Tables/Slot011Table";
import { Slot012Table } from "./Tables/Slot012Table";
import { Slot013Table } from "./Tables/Slot013Table";
import { Slot014Table } from "./Tables/Slot014Table";
import { Slot015Table } from "./Tables/Slot015Table";
import { Slot016Table } from "./Tables/Slot016Table";
import { Slot017Table } from "./Tables/Slot017Table";
import { Slot018Table } from "./Tables/Slot018Table";
import { Slot019Table } from "./Tables/Slot019Table";
import { Slot020Table } from "./Tables/Slot020Table";
import { Slot021Table } from "./Tables/Slot021Table";
import { Slot022Table } from "./Tables/Slot022Table";
import { Slot023Table } from "./Tables/Slot023Table";
import { Slot024Table } from "./Tables/Slot024Table";
import { Slot025Table } from "./Tables/Slot025Table";
import { Slot026Table } from "./Tables/Slot026Table";
import { Slot027Table } from "./Tables/Slot027Table";
import { Slot028Table } from "./Tables/Slot028Table";
import { Slot029Table } from "./Tables/Slot029Table";
import { Slot030Table } from "./Tables/Slot030Table";
import { Slot031Table } from "./Tables/Slot031Table";
import { Slot032Table } from "./Tables/Slot032Table";
import { Slot033Table } from "./Tables/Slot033Table";
import { Slot034Table } from "./Tables/Slot034Table";
import { Slot035Table } from "./Tables/Slot035Table";
import { Slot036Table } from "./Tables/Slot036Table";
import { Slot037Table } from "./Tables/Slot037Table";
import { Slot038Table } from "./Tables/Slot038Table";
import { Slot039Table } from "./Tables/Slot039Table";
import { Slot040Table } from "./Tables/Slot040Table";
import { Slot041Table } from "./Tables/Slot041Table";
import { Slot042Table } from "./Tables/Slot042Table";
import { Slot043Table } from "./Tables/Slot043Table";
import { Slot044Table } from "./Tables/Slot044Table";
import { Slot045Table } from "./Tables/Slot045Table";
import { Slot047Table } from "./Tables/Slot047Table";
import { Slot048Table } from "./Tables/Slot048Table";
import { Slot049Table } from "./Tables/Slot049Table";
import { Slot050Table } from "./Tables/Slot050Table";
import { Slot051Table } from "./Tables/Slot051Table";
import { Slot052Table } from "./Tables/Slot052Table";
import { Slot054Table } from "./Tables/Slot054Table";
import { Slot055Table } from "./Tables/Slot055Table";
import { Slot056Table } from "./Tables/Slot056Table";
import { Slot058Table } from "./Tables/Slot058Table";
import { Slot059Table } from "./Tables/Slot059Table";
import { Slot060Table } from "./Tables/Slot060Table";
import { Slot061Table } from "./Tables/Slot061Table";
import { Slot062Table } from "./Tables/Slot062Table";
import { Slot064Table } from "./Tables/Slot064Table";
import { Slot1201Table } from "./Tables/Slot1201Table";
import { Slot1202Table } from "./Tables/Slot1202Table";
import { Slot1501Table } from "./Tables/Slot1501Table";
import { Slot1701Table } from "./Tables/Slot1701Table";
import { SlotsetTable, SlotsetTableRow } from "./Tables/SlotsetTable";
import { SoundTable, SoundTableRow } from "./Tables/SoundTable";
import { StringTable, StringTableRow } from "./Tables/StringTable";
import { Super6BaccaratTable } from "./Tables/Super6BaccaratTable";
import { Table3031Table } from "./Tables/Table3031Table";
import { TripleBaccaratTable } from "./Tables/TripleBaccaratTable";
import { TwoSicboTable } from "./Tables/TwoSicboTable";
import { VipTable } from "./Tables/VipTable";
//#endregion AutoMappingImport

export default class CSSettingsV3 {

    public static ResetTables() {
        for (let prop in this) {
            if (prop.charAt(0) === '_' && this[prop] && this[prop] instanceof TableBase) {
                let table = this[prop];
                let tableName = prop.replace("_", "#");
                for (let p in table) {
                    if (p.charAt(0) === '_' && table[p] && table[p] instanceof TableBase) {
                        cc.log(`TableV3 [${tableName}${p.replace("_", "#")}] cleared`);
                        table[p] = undefined;
                    }
                }
                cc.log(`TableV3 [${tableName}] cleared`);
                this[prop] = undefined;
            }
        }
        //TODO: 尚未實作TableManager的清除動作
    }

    //#region AutoMappingClass

    private static _monkeytower: MonkeytowerTable;
    /** 捕魚機_西遊塔防#monkeytower.xlsx */
    public static get Monkeytower(): MonkeytowerTable { return this._monkeytower = this._monkeytower || new MonkeytowerTable(); }

    private static _gift: GiftTable;
    /** 系統_贈禮#gift.xlsx */
    public static get Gift(): GiftTable { return this._gift = this._gift || new GiftTable(); }

    private static _fish2003: Fish2003Table;
    /** 捕魚機_乖鵝子捕魚#fish2003.xlsx */
    public static get Fish2003(): Fish2003Table { return this._fish2003 = this._fish2003 || new Fish2003Table(); }

    private static _fish2004: Fish2004Table;
    /** 捕魚機_乖海豹捕魚#fish2004.xlsx */
    public static get Fish2004(): Fish2004Table { return this._fish2004 = this._fish2004 || new Fish2004Table(); }

    private static _tripleBaccarat: TripleBaccaratTable;
    /** 遊藝館_三寶百家樂#triple_baccarat.xlsx */
    public static get TripleBaccarat(): TripleBaccaratTable { return this._tripleBaccarat = this._tripleBaccarat || new TripleBaccaratTable(); }

    private static _nineSicbo: NineSicboTable;
    /** 遊藝館_九龍骰寶#nine_sicbo.xlsx */
    public static get NineSicbo(): NineSicboTable { return this._nineSicbo = this._nineSicbo || new NineSicboTable(); }

    private static _super6Baccarat: Super6BaccaratTable;
    /** 遊藝館_超六百家樂#super6_baccarat.xlsx */
    public static get Super6Baccarat(): Super6BaccaratTable { return this._super6Baccarat = this._super6Baccarat || new Super6BaccaratTable(); }

    private static _table3031: Table3031Table;
    /** 遊藝館_色碟#table3031.xlsx */
    public static get Table3031(): Table3031Table { return this._table3031 = this._table3031 || new Table3031Table(); }

    private static _normalBaccarat: NormalBaccaratTable;
    /** 遊藝館_傳統百家樂#normal_baccarat.xlsx */
    public static get NormalBaccarat(): NormalBaccaratTable { return this._normalBaccarat = this._normalBaccarat || new NormalBaccaratTable(); }

    private static _twoSicbo: TwoSicboTable;
    /** 遊藝館_雙星骰寶#two_sicbo.xlsx */
    public static get TwoSicbo(): TwoSicboTable { return this._twoSicbo = this._twoSicbo || new TwoSicboTable(); }

    private static _slotset: SlotsetTable;
    /** 機台設定#slotset.xlsx */
    public static get Slotset(): SlotsetTable { return this._slotset = this._slotset || TableManager.InitTable("#slotset", SlotsetTable, SlotsetTableRow); }

    private static _bar1401: Bar1401Table;
    /** BAR_1401麻辣小瑪莉#bar_1401.xlsx */
    public static get Bar1401(): Bar1401Table { return this._bar1401 = this._bar1401 || new Bar1401Table(); }

    private static _cluster1302: Cluster1302Table;
    /** Cluster_1302鍊金術士#cluster_1302.xlsx */
    public static get Cluster1302(): Cluster1302Table { return this._cluster1302 = this._cluster1302 || new Cluster1302Table(); }

    private static _collect001: Collect001Table;
    /** COLLECT_001猛瑪#collect_001.xlsx */
    public static get Collect001(): Collect001Table { return this._collect001 = this._collect001 || new Collect001Table(); }

    private static _collect002: Collect002Table;
    /** COLLECT_002幸運美鈔#collect_002.xlsx */
    public static get Collect002(): Collect002Table { return this._collect002 = this._collect002 || new Collect002Table(); }

    private static _slot002: Slot002Table;
    /** SLOT_002火焰巨輪#slot_002.xlsx */
    public static get Slot002(): Slot002Table { return this._slot002 = this._slot002 || new Slot002Table(); }

    private static _slot001: Slot001Table;
    /** SLOT_001福氣財神#slot_001.xlsx */
    public static get Slot001(): Slot001Table { return this._slot001 = this._slot001 || new Slot001Table(); }

    private static _slot003: Slot003Table;
    /** SLOT_003翻轉提基#slot_003.xlsx */
    public static get Slot003(): Slot003Table { return this._slot003 = this._slot003 || new Slot003Table(); }

    private static _slot004: Slot004Table;
    /** SLOT_004埃及#slot_004.xlsx */
    public static get Slot004(): Slot004Table { return this._slot004 = this._slot004 || new Slot004Table(); }

    private static _slot005: Slot005Table;
    /** SLOT_005雷電#slot_005.xlsx */
    public static get Slot005(): Slot005Table { return this._slot005 = this._slot005 || new Slot005Table(); }

    private static _slot006: Slot006Table;
    /** SLOT_006四方美人#slot_006.xlsx */
    public static get Slot006(): Slot006Table { return this._slot006 = this._slot006 || new Slot006Table(); }

    private static _slot007: Slot007Table;
    /** SLOT_007鍊金術師#slot_007.xlsx */
    public static get Slot007(): Slot007Table { return this._slot007 = this._slot007 || new Slot007Table(); }

    private static _slot008: Slot008Table;
    /** SLOT_008鯊魚#slot_008.xlsx */
    public static get Slot008(): Slot008Table { return this._slot008 = this._slot008 || new Slot008Table(); }

    private static _slot010: Slot010Table;
    /** SLOT_010紅利金貓#slot_010.xlsx */
    public static get Slot010(): Slot010Table { return this._slot010 = this._slot010 || new Slot010Table(); }

    private static _slot009: Slot009Table;
    /** SLOT_009美女與野獸#slot_009.xlsx */
    public static get Slot009(): Slot009Table { return this._slot009 = this._slot009 || new Slot009Table(); }

    private static _slot011: Slot011Table;
    /** SLOT_011戀愛學園祭#slot_011.xlsx */
    public static get Slot011(): Slot011Table { return this._slot011 = this._slot011 || new Slot011Table(); }

    private static _slot013: Slot013Table;
    /** SLOT_013年獸獻瑞#slot_013.xlsx */
    public static get Slot013(): Slot013Table { return this._slot013 = this._slot013 || new Slot013Table(); }

    private static _slot012: Slot012Table;
    /** SLOT_012魔法少女#slot_012.xlsx */
    public static get Slot012(): Slot012Table { return this._slot012 = this._slot012 || new Slot012Table(); }

    private static _slot016: Slot016Table;
    /** SLOT_016風暴女王#slot_016.xlsx */
    public static get Slot016(): Slot016Table { return this._slot016 = this._slot016 || new Slot016Table(); }

    private static _slot014: Slot014Table;
    /** SLOT_014騎士風雲#slot_014.xlsx */
    public static get Slot014(): Slot014Table { return this._slot014 = this._slot014 || new Slot014Table(); }

    private static _slot015: Slot015Table;
    /** SLOT_015神鬼戰士#slot_015.xlsx */
    public static get Slot015(): Slot015Table { return this._slot015 = this._slot015 || new Slot015Table(); }

    private static _slot017: Slot017Table;
    /** SLOT_017帽子#slot_017.xlsx */
    public static get Slot017(): Slot017Table { return this._slot017 = this._slot017 || new Slot017Table(); }

    private static _slot019: Slot019Table;
    /** SLOT_019礦坑#slot_019.xlsx */
    public static get Slot019(): Slot019Table { return this._slot019 = this._slot019 || new Slot019Table(); }

    private static _slot018: Slot018Table;
    /** SLOT_018搖錢樹#slot_018.xlsx */
    public static get Slot018(): Slot018Table { return this._slot018 = this._slot018 || new Slot018Table(); }

    private static _slot020: Slot020Table;
    /** SLOT_020特務奇兵#slot_020.xlsx */
    public static get Slot020(): Slot020Table { return this._slot020 = this._slot020 || new Slot020Table(); }

    private static _slot022: Slot022Table;
    /** SLOT_022提基酒吧#slot_022.xlsx */
    public static get Slot022(): Slot022Table { return this._slot022 = this._slot022 || new Slot022Table(); }

    private static _slot021: Slot021Table;
    /** SLOT_021火山#slot_021.xlsx */
    public static get Slot021(): Slot021Table { return this._slot021 = this._slot021 || new Slot021Table(); }

    private static _slot024: Slot024Table;
    /** SLOT_024多福多財#slot_024.xlsx */
    public static get Slot024(): Slot024Table { return this._slot024 = this._slot024 || new Slot024Table(); }

    private static _slot025: Slot025Table;
    /** SLOT_025鑽石之都#slot_025.xlsx */
    public static get Slot025(): Slot025Table { return this._slot025 = this._slot025 || new Slot025Table(); }

    private static _slot026: Slot026Table;
    /** SLOT_026純金#slot_026.xlsx */
    public static get Slot026(): Slot026Table { return this._slot026 = this._slot026 || new Slot026Table(); }

    private static _slot027: Slot027Table;
    /** SLOT_027富貴神龍#slot_027.xlsx */
    public static get Slot027(): Slot027Table { return this._slot027 = this._slot027 || new Slot027Table(); }

    private static _slot029: Slot029Table;
    /** SLOT_029十倍經典#slot_029.xlsx */
    public static get Slot029(): Slot029Table { return this._slot029 = this._slot029 || new Slot029Table(); }

    private static _slot028: Slot028Table;
    /** SLOT_028百萬金輪#slot_028.xlsx */
    public static get Slot028(): Slot028Table { return this._slot028 = this._slot028 || new Slot028Table(); }

    private static _slot030: Slot030Table;
    /** SLOT_030龍鳳呈祥#slot_030.xlsx */
    public static get Slot030(): Slot030Table { return this._slot030 = this._slot030 || new Slot030Table(); }

    private static _slot031: Slot031Table;
    /** SLOT_031水滸英雄#slot_031.xlsx */
    public static get Slot031(): Slot031Table { return this._slot031 = this._slot031 || new Slot031Table(); }

    private static _slot033: Slot033Table;
    /** SLOT_033香水玫瑰#slot_033.xlsx */
    public static get Slot033(): Slot033Table { return this._slot033 = this._slot033 || new Slot033Table(); }

    private static _slot032: Slot032Table;
    /** SLOT_032埃及豔后#slot_032.xlsx */
    public static get Slot032(): Slot032Table { return this._slot032 = this._slot032 || new Slot032Table(); }

    private static _slot034: Slot034Table;
    /** SLOT_034招財金貓#slot_034.xlsx */
    public static get Slot034(): Slot034Table { return this._slot034 = this._slot034 || new Slot034Table(); }

    private static _slot035: Slot035Table;
    /** SLOT_035多金多銀#slot_035.xlsx */
    public static get Slot035(): Slot035Table { return this._slot035 = this._slot035 || new Slot035Table(); }

    private static _slot037: Slot037Table;
    /** SLOT_037幸運七#slot_037.xlsx */
    public static get Slot037(): Slot037Table { return this._slot037 = this._slot037 || new Slot037Table(); }

    private static _slot036: Slot036Table;
    /** SLOT_036驚奇之星#slot_036.xlsx */
    public static get Slot036(): Slot036Table { return this._slot036 = this._slot036 || new Slot036Table(); }

    private static _slot038: Slot038Table;
    /** SLOT_038經典九線#slot_038.xlsx */
    public static get Slot038(): Slot038Table { return this._slot038 = this._slot038 || new Slot038Table(); }

    private static _slot039: Slot039Table;
    /** SLOT_039閃電倒轉#slot_039.xlsx */
    public static get Slot039(): Slot039Table { return this._slot039 = this._slot039 || new Slot039Table(); }

    private static _slot040: Slot040Table;
    /** SLOT_040海姬#slot_040.xlsx */
    public static get Slot040(): Slot040Table { return this._slot040 = this._slot040 || new Slot040Table(); }

    private static _slot041: Slot041Table;
    /** SLOT_041愛麗絲#slot_041.xlsx */
    public static get Slot041(): Slot041Table { return this._slot041 = this._slot041 || new Slot041Table(); }

    private static _slot042: Slot042Table;
    /** SLOT_042好運到#slot_042.xlsx */
    public static get Slot042(): Slot042Table { return this._slot042 = this._slot042 || new Slot042Table(); }

    private static _slot043: Slot043Table;
    /** SLOT_043亞歷山大#slot_043.xlsx */
    public static get Slot043(): Slot043Table { return this._slot043 = this._slot043 || new Slot043Table(); }

    private static _slot044: Slot044Table;
    /** SLOT_044五龍#slot_044.xlsx */
    public static get Slot044(): Slot044Table { return this._slot044 = this._slot044 || new Slot044Table(); }

    private static _slot045: Slot045Table;
    /** SLOT_045齊天大聖#slot_045.xlsx */
    public static get Slot045(): Slot045Table { return this._slot045 = this._slot045 || new Slot045Table(); }

    private static _slot047: Slot047Table;
    /** SLOT_047財神降臨#slot_047.xlsx */
    public static get Slot047(): Slot047Table { return this._slot047 = this._slot047 || new Slot047Table(); }

    private static _slot048: Slot048Table;
    /** SLOT_048福星88#slot_048.xlsx */
    public static get Slot048(): Slot048Table { return this._slot048 = this._slot048 || new Slot048Table(); }

    private static _slot049: Slot049Table;
    /** SLOT_049熊貓#slot_049.xlsx */
    public static get Slot049(): Slot049Table { return this._slot049 = this._slot049 || new Slot049Table(); }

    private static _slot050: Slot050Table;
    /** SLOT_050吉鼓發財#slot_050.xlsx */
    public static get Slot050(): Slot050Table { return this._slot050 = this._slot050 || new Slot050Table(); }

    private static _slot051: Slot051Table;
    /** SLOT_051皇帝88#slot_051.xlsx */
    public static get Slot051(): Slot051Table { return this._slot051 = this._slot051 || new Slot051Table(); }

    private static _slot052: Slot052Table;
    /** SLOT_052HUGA#slot_052.xlsx */
    public static get Slot052(): Slot052Table { return this._slot052 = this._slot052 || new Slot052Table(); }

    private static _slot054: Slot054Table;
    /** SLOT_054猛瑪#slot_054.xlsx */
    public static get Slot054(): Slot054Table { return this._slot054 = this._slot054 || new Slot054Table(); }

    private static _slot056: Slot056Table;
    /** SLOT_056彩虹筆#slot_056.xlsx */
    public static get Slot056(): Slot056Table { return this._slot056 = this._slot056 || new Slot056Table(); }

    private static _slot055: Slot055Table;
    /** SLOT_055幸運美鈔#slot_055.xlsx */
    public static get Slot055(): Slot055Table { return this._slot055 = this._slot055 || new Slot055Table(); }

    private static _slot058: Slot058Table;
    /** SLOT_058鳳凰之怒#slot_058.xlsx */
    public static get Slot058(): Slot058Table { return this._slot058 = this._slot058 || new Slot058Table(); }

    private static _slot059: Slot059Table;
    /** SLOT_059多福單機版#slot_059.xlsx */
    public static get Slot059(): Slot059Table { return this._slot059 = this._slot059 || new Slot059Table(); }

    private static _slot060: Slot060Table;
    /** SLOT_060無限連段#slot_060.xlsx */
    public static get Slot060(): Slot060Table { return this._slot060 = this._slot060 || new Slot060Table(); }

    private static _slot061: Slot061Table;
    /** SLOT_061魔術方塊#slot_061.xlsx */
    public static get Slot061(): Slot061Table { return this._slot061 = this._slot061 || new Slot061Table(); }

    private static _bingo: BingoTable;
    /** 系統_賓果#bingo.xlsx */
    public static get Bingo(): BingoTable { return this._bingo = this._bingo || new BingoTable(); }

    private static _slot1201: Slot1201Table;
    /** SLOT_1201三勇者#slot_1201.xlsx */
    public static get Slot1201(): Slot1201Table { return this._slot1201 = this._slot1201 || new Slot1201Table(); }

    private static _slot1202: Slot1202Table;
    /** SLOT_1202迴轉壽司#slot_1202.xlsx */
    public static get Slot1202(): Slot1202Table { return this._slot1202 = this._slot1202 || new Slot1202Table(); }

    private static _slot023: Slot023Table;
    /** SLOT_023888巨輪#slot_023.xlsx */
    public static get Slot023(): Slot023Table { return this._slot023 = this._slot023 || new Slot023Table(); }

    private static _slot1501: Slot1501Table;
    /** SLOT_1501柏青哥_金貓#slot_1501.xlsx */
    public static get Slot1501(): Slot1501Table { return this._slot1501 = this._slot1501 || new Slot1501Table(); }

    private static _string: StringTable;
    /** 共用_字串表#string.xlsx */
    public static get String(): StringTable { return this._string = this._string || TableManager.InitTable("#string", StringTable, StringTableRow); }

    private static _line: LineTable;
    /** 共用_走線表#line.xlsx */
    public static get Line(): LineTable { return this._line = this._line || new LineTable(); }

    private static _shop: ShopTable;
    /** 共用_商城#shop.xlsx */
    public static get Shop(): ShopTable { return this._shop = this._shop || new ShopTable(); }

    private static _currency: CurrencyTable;
    /** 共用_幣別表#currency.xlsx */
    public static get Currency(): CurrencyTable { return this._currency = this._currency || TableManager.InitTable("#currency", CurrencyTable, CurrencyTableRow); }

    private static _language: LanguageTable;
    /** 共用_語系表#language.xlsx */
    public static get Language(): LanguageTable { return this._language = this._language || new LanguageTable(); }

    private static _fixed: FixedTable;
    /** 共用_數值表#fixed.xlsx */
    public static get Fixed(): FixedTable { return this._fixed = this._fixed || TableManager.InitTable("#fixed", FixedTable, FixedTableRow); }

    private static _vip: VipTable;
    /** 系統_VIP#vip.xlsx */
    public static get Vip(): VipTable { return this._vip = this._vip || new VipTable(); }

    private static _five: FiveTable;
    /** 系統_五星彩#five.xlsx */
    public static get Five(): FiveTable { return this._five = this._five || new FiveTable(); }

    private static _formread: FormreadTable;
    /** 系統_表單讀取#formread.xlsx */
    public static get Formread(): FormreadTable { return this._formread = this._formread || TableManager.InitTable("#formread", FormreadTable, FormreadTableRow); }

    private static _mail: MailTable;
    /** 系統_信件#mail.xlsx */
    public static get Mail(): MailTable { return this._mail = this._mail || new MailTable(); }

    private static _sound: SoundTable;
    /** 系統_音效表#sound.xlsx */
    public static get Sound(): SoundTable { return this._sound = this._sound || TableManager.InitTable("#sound", SoundTable, SoundTableRow); }

    private static _rank: RankTable;
    /** 系統_排行榜#rank.xlsx */
    public static get Rank(): RankTable { return this._rank = this._rank || TableManager.InitTable("#rank", RankTable, RankTableRow); }

    private static _chat: ChatTable;
    /** 系統_聊天室#chat.xlsx */
    public static get Chat(): ChatTable { return this._chat = this._chat || new ChatTable(); }

    private static _level: LevelTable;
    /** 系統_等級表#level.xlsx */
    public static get Level(): LevelTable { return this._level = this._level || TableManager.InitTable("#level", LevelTable, LevelTableRow); }

    private static _network: NetworkTable;
    /** 系統_跑馬燈#network.xlsx */
    public static get Network(): NetworkTable { return this._network = this._network || new NetworkTable(); }

    private static _itemdrop: ItemdropTable;
    /** 系統_道具掉落表#itemdrop.xlsx */
    public static get Itemdrop(): ItemdropTable { return this._itemdrop = this._itemdrop || new ItemdropTable(); }

    private static _itemmoney: ItemmoneyTable;
    /** 系統_道具價錢表#itemmoney.xlsx */
    public static get Itemmoney(): ItemmoneyTable { return this._itemmoney = this._itemmoney || new ItemmoneyTable(); }

    private static _name: NameTable;
    /** 系統_暱稱#name.xlsx */
    public static get Name(): NameTable { return this._name = this._name || new NameTable(); }

    private static _lobby: LobbyTable;
    /** 系統_機台分桌#lobby.xlsx */
    public static get Lobby(): LobbyTable { return this._lobby = this._lobby || new LobbyTable(); }

    private static _head: HeadTable;
    /** 系統_頭像#head.xlsx */
    public static get Head(): HeadTable { return this._head = this._head || TableManager.InitTable("#head", HeadTable, HeadTableRow); }

    private static _itemSetting: ItemSettingTable;
    /** 系統_道具設定#item_setting.xlsx */
    public static get ItemSetting(): ItemSettingTable { return this._itemSetting = this._itemSetting || new ItemSettingTable(); }

    private static _cardUpgrade: CardUpgradeTable;
    /** 系統_卡片強化#card_upgrade.xlsx */
    public static get CardUpgrade(): CardUpgradeTable { return this._cardUpgrade = this._cardUpgrade || new CardUpgradeTable(); }

    private static _betSetting: BetSettingTable;
    /** 共用_幣種設定表#bet_setting.xlsx */
    public static get BetSetting(): BetSettingTable { return this._betSetting = this._betSetting || new BetSettingTable(); }

    private static _packet: PacketTable;
    /** 系統_背包#packet.xlsx */
    public static get Packet(): PacketTable { return this._packet = this._packet || new PacketTable(); }

    private static _composite: CompositeTable;
    /** 系統_合成表#composite.xlsx */
    public static get Composite(): CompositeTable { return this._composite = this._composite || new CompositeTable(); }

    private static _bingo9stars: Bingo9starsTable;
    /** SLOT_1102彩票_九星彩#bingo_9stars.xlsx */
    public static get Bingo9stars(): Bingo9starsTable { return this._bingo9stars = this._bingo9stars || new Bingo9starsTable(); }

    private static _bingo8stars: Bingo8starsTable;
    /** SLOT_1101彩票_百搭八星彩#bingo_8stars.xlsx */
    public static get Bingo8stars(): Bingo8starsTable { return this._bingo8stars = this._bingo8stars || new Bingo8starsTable(); }

    private static _slot1701: Slot1701Table;
    /** SLOT_1701一錘千金#slot_1701.xlsx */
    public static get Slot1701(): Slot1701Table { return this._slot1701 = this._slot1701 || new Slot1701Table(); }

    private static _slot062: Slot062Table;
    /** SLOT_062常勝將軍#slot_062.xlsx */
    public static get Slot062(): Slot062Table { return this._slot062 = this._slot062 || new Slot062Table(); }

    private static _cluster1303: Cluster1303Table;
    /** Cluster_1303糖果爆炸#cluster_1303.xlsx */
    public static get Cluster1303(): Cluster1303Table { return this._cluster1303 = this._cluster1303 || new Cluster1303Table(); }

    private static _slot064: Slot064Table;
    /** SLOT_064小姐姐釣大魚#slot_064.xlsx */
    public static get Slot064(): Slot064Table { return this._slot064 = this._slot064 || new Slot064Table(); }

    private static _operation: OperationTable;
    /** 系統_營運活動#operation.xlsx */
    public static get Operation(): OperationTable { return this._operation = this._operation || new OperationTable(); }

    //#endregion AutoMappingClass
}
