﻿import { ITableRow, WithoutRow } from "../../Engine/CatanEngine/TableV3/Core/ITableRow";
import { TableBase } from "../../Engine/CatanEngine/TableV3/Core/TableBase";
import { TableManager } from "../../Engine/CatanEngine/TableV3/TableManager";

/**
 * 系統_合成表#composite.xlsx
 * ##程式碼由工具產生, 在此做的修改都將被覆蓋##
 */
export class CompositeTable extends TableBase<WithoutRow> {
	private _chip: ChipTable;
	/**  系統_合成表#composite.xlsx > #chip */
	public get Chip(): ChipTable { return this._chip = this._chip || TableManager.InitTable("#composite#chip", ChipTable, ChipTableRow); }
}

/**
 * #chip
 */
export class ChipTable extends TableBase<ChipTableRow> {}

export class ChipTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 碎片1 */
	Chip1: any;
	/** 碎片2 */
	Chip2: any;
	/** 碎片3 */
	Chip3: any;
	/** 碎片4 */
	Chip4: any;
	/** 碎片5 */
	Chip5: any;
	/** 碎片6 */
	Chip6: any;
}
