﻿import { ITableRow, WithoutRow } from "../../Engine/CatanEngine/TableV3/Core/ITableRow";
import { TableBase } from "../../Engine/CatanEngine/TableV3/Core/TableBase";
import { TableManager } from "../../Engine/CatanEngine/TableV3/TableManager";

/**
 * 系統_道具價錢表#itemmoney.xlsx
 * ##程式碼由工具產生, 在此做的修改都將被覆蓋##
 */
export class ItemmoneyTable extends TableBase<WithoutRow> {
	private _chip: ChipTable;
	/**  系統_道具價錢表#itemmoney.xlsx > #chip */
	public get Chip(): ChipTable { return this._chip = this._chip || TableManager.InitTable("#itemmoney#chip", ChipTable, ChipTableRow); }
}

/**
 * #chip
 */
export class ChipTable extends TableBase<ChipTableRow> {}

export class ChipTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 體驗 */
	Sale1: number;
	/** 一般 */
	Sale2: number;
	/** 高手 */
	Sale3: number;
	/** 至尊 */
	Sale4: number;
}
