﻿import { ITableRow, WithoutRow } from "../../Engine/CatanEngine/TableV3/Core/ITableRow";
import { TableBase } from "../../Engine/CatanEngine/TableV3/Core/TableBase";
import { TableManager } from "../../Engine/CatanEngine/TableV3/TableManager";

/**
 * 系統_信件#mail.xlsx
 * ##程式碼由工具產生, 在此做的修改都將被覆蓋##
 */
export class MailTable extends TableBase<WithoutRow> {
	private _stringMail: StringMailTable;
	/**  系統_信件#mail.xlsx > #string_mail */
	public get StringMail(): StringMailTable { return this._stringMail = this._stringMail || TableManager.InitTable("#mail#string_mail", StringMailTable, StringMailTableRow); }
}

/**
 * #string_mail
 */
export class StringMailTable extends TableBase<StringMailTableRow> {}

export class StringMailTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 繁體中文訊息 */
	MsgZnTw: string;
	/** 簡體中文讯息 */
	MsgZnCh: string;
	/** 英文訊息 */
	MsgEn: string;
}
