﻿import { ITableRow, WithoutRow } from "../../Engine/CatanEngine/TableV3/Core/ITableRow";
import { TableBase } from "../../Engine/CatanEngine/TableV3/Core/TableBase";
import { TableManager } from "../../Engine/CatanEngine/TableV3/TableManager";

/**
 * SLOT_1701一錘千金#slot_1701.xlsx
 * ##程式碼由工具產生, 在此做的修改都將被覆蓋##
 */
export class Slot1701Table extends TableBase<WithoutRow> {
	private _fixed: FixedTable;
	/**  SLOT_1701一錘千金#slot_1701.xlsx > #fixed */
	public get Fixed(): FixedTable { return this._fixed = this._fixed || TableManager.InitTable("#slot_1701#fixed", FixedTable, FixedTableRow); }

	private _symbol: SymbolTable;
	/**  SLOT_1701一錘千金#slot_1701.xlsx > #symbol */
	public get Symbol(): SymbolTable { return this._symbol = this._symbol || TableManager.InitTable("#slot_1701#symbol", SymbolTable, SymbolTableRow); }

	private _destiny: DestinyTable;
	/**  SLOT_1701一錘千金#slot_1701.xlsx > #destiny */
	public get Destiny(): DestinyTable { return this._destiny = this._destiny || TableManager.InitTable("#slot_1701#destiny", DestinyTable, DestinyTableRow); }

	private _pay: PayTable;
	/**  SLOT_1701一錘千金#slot_1701.xlsx > #pay */
	public get Pay(): PayTable { return this._pay = this._pay || TableManager.InitTable("#slot_1701#pay", PayTable, PayTableRow); }

	private _sound: SoundTable;
	/**  SLOT_1701一錘千金#slot_1701.xlsx > #sound */
	public get Sound(): SoundTable { return this._sound = this._sound || TableManager.InitTable("#slot_1701#sound", SoundTable, SoundTableRow); }

	private _string: StringTable;
	/**  SLOT_1701一錘千金#slot_1701.xlsx > #string */
	public get String(): StringTable { return this._string = this._string || TableManager.InitTable("#slot_1701#string", StringTable, StringTableRow); }

	private _wheelForm: WheelFormTable;
	/**  SLOT_1701一錘千金#slot_1701.xlsx > #wheel_form */
	public get WheelForm(): WheelFormTable { return this._wheelForm = this._wheelForm || TableManager.InitTable("#slot_1701#wheel_form", WheelFormTable, WheelFormTableRow); }
}

/**
 * #fixed
 */
export class FixedTable extends TableBase<FixedTableRow> {}

export class FixedTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 共用(值) */
	BValue: number;
	/** client專用(值) */
	CValue: number;
}

/**
 * #symbol
 */
export class SymbolTable extends TableBase<SymbolTableRow> {}

export class SymbolTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 0-1階碎裂%數 */
	CValue1: number;
	/** 1-2階碎裂%數 */
	CValue2: number;
	/** 2-3階碎裂%數 */
	CValue3: number;
	/** 3-4階碎裂%數 */
	CValue4: number;
}

/**
 * #destiny
 */
export class DestinyTable extends TableBase<DestinyTableRow> {}

export class DestinyTableRow implements ITableRow {
	/** 編號 */
	Id: number;
}

/**
 * #pay
 */
export class PayTable extends TableBase<PayTableRow> {}

export class PayTableRow implements ITableRow {
	/** 編號 */
	Id: number;
}

/**
 * #sound
 */
export class SoundTable extends TableBase<SoundTableRow> {}

export class SoundTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 音效=1, 音樂 = 2 */
	Type: number;
	/** 繁體中文音檔位置(預設音檔位置) */
	PathZnTw: string;
}

/**
 * #string
 */
export class StringTable extends TableBase<StringTableRow> {}

export class StringTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 英文訊息 */
	MsgEn: string;
	/** 繁體中文訊息 */
	MsgZnTw: string;
	/** 簡體中文讯息 */
	MsgZnCh: string;
}

/**
 * #wheel_form
 */
export class WheelFormTable extends TableBase<WheelFormTableRow> {}

export class WheelFormTableRow implements ITableRow {
	/** 編號 */
	Id: number;
}
