import { FixedTable } from "../Tables/FixedTable";

declare module '../Tables/FixedTable' {
    interface FixedTable {
        GetBigWinGameblingRate(idx: number): number;
        GetBigWinGameblingRatePerSec(idx: number) : number;
    }
}

FixedTable.prototype.GetBigWinGameblingRate = function (idx: number) {
    let self = <FixedTable>this;
    return self[201 + idx].Value;
}

FixedTable.prototype.GetBigWinGameblingRatePerSec = function (idx: number){
    let self = <FixedTable>this;
    return self[221 + idx].Value;
}