﻿import { ITableRow, WithoutRow } from "../../Engine/CatanEngine/TableV3/Core/ITableRow";
import { TableBase } from "../../Engine/CatanEngine/TableV3/Core/TableBase";
import { TableManager } from "../../Engine/CatanEngine/TableV3/TableManager";

/**
 * 共用_語系表#language.xlsx
 * ##程式碼由工具產生, 在此做的修改都將被覆蓋##
 */
export class LanguageTable extends TableBase<WithoutRow> {
	private _lanuage: LanuageTable;
	/**  共用_語系表#language.xlsx > #lanuage */
	public get Lanuage(): LanuageTable { return this._lanuage = this._lanuage || TableManager.InitTable("#language#lanuage", LanuageTable, LanuageTableRow); }
}

/**
 * #lanuage
 */
export class LanuageTable extends TableBase<LanuageTableRow> {}

export class LanuageTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 名稱 */
	Name: string;
	/** 代碼 */
	Type: string;
	/** 對應字串表欄位 */
	Msg: string;
	/** 對應語言包檔名 */
	Path: string;
	/** 對應音效欄位 */
	SoundPath: string;
	/** 是否顯示在設定 */
	App: number;
}
