﻿import { ITableRow, WithoutRow } from "../../Engine/CatanEngine/TableV3/Core/ITableRow";
import { TableBase } from "../../Engine/CatanEngine/TableV3/Core/TableBase";
import { TableManager } from "../../Engine/CatanEngine/TableV3/TableManager";

/**
 * 系統_暱稱#name.xlsx
 * ##程式碼由工具產生, 在此做的修改都將被覆蓋##
 */
export class NameTable extends TableBase<WithoutRow> {
	private _banstring: BanstringTable;
	/**  系統_暱稱#name.xlsx > #banstring */
	public get Banstring(): BanstringTable { return this._banstring = this._banstring || TableManager.InitTable("#name#banstring", BanstringTable, BanstringTableRow); }
}

/**
 * #banstring
 */
export class BanstringTable extends TableBase<BanstringTableRow> {}

export class BanstringTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 禁字 */
	Word: string;
}
