﻿import { ITableRow, WithoutRow } from "../../Engine/CatanEngine/TableV3/Core/ITableRow";
import { TableBase } from "../../Engine/CatanEngine/TableV3/Core/TableBase";
import { TableManager } from "../../Engine/CatanEngine/TableV3/TableManager";

/**
 * SLOT_1202迴轉壽司#slot_1202.xlsx
 * ##程式碼由工具產生, 在此做的修改都將被覆蓋##
 */
export class Slot1202Table extends TableBase<WithoutRow> {
	private _fixed: FixedTable;
	/**  SLOT_1202迴轉壽司#slot_1202.xlsx > #fixed */
	public get Fixed(): FixedTable { return this._fixed = this._fixed || TableManager.InitTable("#slot_1202#fixed", FixedTable, FixedTableRow); }

	private _mystery: MysteryTable;
	/**  SLOT_1202迴轉壽司#slot_1202.xlsx > #mystery */
	public get Mystery(): MysteryTable { return this._mystery = this._mystery || TableManager.InitTable("#slot_1202#mystery", MysteryTable, MysteryTableRow); }

	private _symbol: SymbolTable;
	/**  SLOT_1202迴轉壽司#slot_1202.xlsx > #symbol */
	public get Symbol(): SymbolTable { return this._symbol = this._symbol || TableManager.InitTable("#slot_1202#symbol", SymbolTable, SymbolTableRow); }

	private _pay: PayTable;
	/**  SLOT_1202迴轉壽司#slot_1202.xlsx > #pay */
	public get Pay(): PayTable { return this._pay = this._pay || TableManager.InitTable("#slot_1202#pay", PayTable, PayTableRow); }

	private _symbolGroup: SymbolGroupTable;
	/**  SLOT_1202迴轉壽司#slot_1202.xlsx > #symbol_group */
	public get SymbolGroup(): SymbolGroupTable { return this._symbolGroup = this._symbolGroup || TableManager.InitTable("#slot_1202#symbol_group", SymbolGroupTable, SymbolGroupTableRow); }

	private _sound: SoundTable;
	/**  SLOT_1202迴轉壽司#slot_1202.xlsx > #sound */
	public get Sound(): SoundTable { return this._sound = this._sound || TableManager.InitTable("#slot_1202#sound", SoundTable, SoundTableRow); }

	private _wheelForm: WheelFormTable;
	/**  SLOT_1202迴轉壽司#slot_1202.xlsx > #wheel_form */
	public get WheelForm(): WheelFormTable { return this._wheelForm = this._wheelForm || TableManager.InitTable("#slot_1202#wheel_form", WheelFormTable, WheelFormTableRow); }
}

/**
 * #fixed
 */
export class FixedTable extends TableBase<FixedTableRow> {}

export class FixedTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 共用(值) */
	BValue: number;
	/** client專用(值) */
	CValue: number;
}

/**
 * #mystery
 */
export class MysteryTable extends TableBase<MysteryTableRow> {}

export class MysteryTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 範圍 */
	Range: any;
}

/**
 * #symbol
 */
export class SymbolTable extends TableBase<SymbolTableRow> {}

export class SymbolTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 圖檔索引 */
	PicIndex: number;
	/** 重複位移 */
	SameShift: number;
}

/**
 * #pay
 */
export class PayTable extends TableBase<PayTableRow> {}

export class PayTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 賠率 */
	X1: number;
	/** 賠率 */
	X2: number;
	/** 賠率 */
	X3: number;
	/** 賠率 */
	X4: number;
}

/**
 * #symbol_group
 */
export class SymbolGroupTable extends TableBase<SymbolGroupTableRow> {}

export class SymbolGroupTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 圖標 */
	NormalSymbol: number;
	/** 圖標 */
	LevelupSymbol: number;
	/** 圖標 */
	LevelmaxSymbol: number;
}

/**
 * #sound
 */
export class SoundTable extends TableBase<SoundTableRow> {}

export class SoundTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 音效=1, 音樂 = 2 */
	Type: number;
	/** 繁體中文音檔位置(預設音檔位置) */
	PathZnTw: string;
}

/**
 * #wheel_form
 */
export class WheelFormTable extends TableBase<WheelFormTableRow> {}

export class WheelFormTableRow implements ITableRow {
	/** 編號 */
	Id: number;
}
