﻿import { ITableRow, WithoutRow } from "../../Engine/CatanEngine/TableV3/Core/ITableRow";
import { TableBase } from "../../Engine/CatanEngine/TableV3/Core/TableBase";
import { TableManager } from "../../Engine/CatanEngine/TableV3/TableManager";

/**
 * 機台設定#slotset.xlsx
 * ##程式碼由工具產生, 在此做的修改都將被覆蓋##
 */
export class SlotsetTable extends TableBase<SlotsetTableRow> {}

export class SlotsetTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 直橫樣式 */
	Pl: number;
	/** 繁體名稱 */
	NameTw: string;
	/** 簡體名稱 */
	NameCn: string;
	/** 英文名稱 */
	NameEn: string;
	/** 前端設定擋名稱 */
	NameSetting: string;
	/** 檔名 */
	FormName: any;
	/** 判斷滾分 */
	Roll: number;
	/** 版號 */
	Version: number;
	/** 網站 */
	Web: number;
}
